//---------------------------------------------------------------------------
#ifndef ShellTreeViewH
#define ShellTreeViewH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <shlobj.h>
//---------------------------------------------------------------------------
#define HasSubFolder(attr)  (attr & SFGAO_HASSUBFOLDER)
#define IsFileSystem(attr)  (attr & (SFGAO_FILESYSTEM | SFGAO_FILESYSANCESTOR))
//---------------------------------------------------------------------------
class PACKAGE TShellTreeView : public TWinControl
{
private:
    TTreeView *tree;
    TImageList *images;
    TNotifyEvent FOnChange;
    IMalloc *malloc;
    void __fastcall CreateWnd();
    void __fastcall OnTreeViewChange(System::TObject* Sender, TTreeNode* Node);
    void __fastcall OnExpandTreeNode(System::TObject* Sender, TTreeNode* Node, bool &AllowExpansion);
    void __fastcall OnDeleteTreeNode(System::TObject* Sender, TTreeNode* Node);
    void __fastcall OnCompareTreeNode(System::TObject* Sender, TTreeNode* Node1, TTreeNode* Node2, int Data, int &Compare);
    void __fastcall OnGetImageIndex(System::TObject* Sender, TTreeNode* Node);
    void __fastcall OnGetSelectedIndex(System::TObject* Sender, TTreeNode* Node);
    ITEMIDLIST* __fastcall GetFullPidl(TTreeNode *node);
    TTreeNode* __fastcall CreateTreeNode(TTreeNode *node, IShellFolder *folder, ITEMIDLIST *pidl);
    TTreeNode* __fastcall CreateRoot();
    void __fastcall RefreshChildTreeNode(TTreeNode *node);
    void __fastcall RefreshTreeNode(TTreeNode *node);
    bool __fastcall GetHotTrack();
    void __fastcall SetHotTrack(bool hotTrack);
protected:
public:
    __fastcall TShellTreeView(TComponent* Owner);
    __fastcall ~TShellTreeView();
    void __fastcall RefreshTree();
__published:
    __property Align;
    __property Enabled;
    __property bool HotTrack = {read = GetHotTrack, write = SetHotTrack};
    __property TabOrder;
    __property TabStop;
    __property Visible;
    __property TNotifyEvent OnChange = {read = FOnChange, write = FOnChange};
};
//---------------------------------------------------------------------------
#endif
